/*****
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *****/

#ifndef _MUSIC_H_
#define _MUSIC_H_

#include <string>
#include "SDL/SDL_mixer.h"
#include "SDL/SDL.h"

#ifdef WIN32
#include "smpeg/smpeg.h"
#endif

class Music
{
	public:
		Music();
		virtual ~Music();
		int Config();
		// will change later to play song that server tells us
		int PlayMusic (std::string name, int volume = 0);
		int PlayMusic (int id, int format, int volume = 0);
		void MusicVolume( int volume);// * deprecated *
	
	private:
		Mix_Music *music;
#ifdef WIN32
	SMPEG *mpeg;
        SMPEG_Info info;
#endif
};

#endif	//_MUSIC_H_

